/*Location Class - implements  Comparable
 *
 *Has a pair of int x, y coordinates with get and set x and y.
 *
 */

public class Location implements Comparable
{
	private int x,y;
	private double dX, dY;
	
	public Location(int r, int c)
	{
		y = r;
		x = c;
		dX = (double)x;
		dY = (double)y;
	}
	
	public Location(double r, double c)
	{
		y = (int)r;
		x = (int)c;
		dX = c;
		dY = r;
	}
	
	public void setX(int i)
	{
		x = i;
		dX = (double)x;
	}
	
	public void setX(double i)
	{
		dX = i;
		x = (int)dX;
	}
	
	public void setY(int i)
	{
		y = i;
		dY = (double)y;
	}
	
	public void setY(double i)
	{
		dY = i;
		y = (int)dY;
	}
	
	public int getX()
	{
		return (int)dX;
	}
	
	public double getDX()
	{
		return dX;
	}
	
	public int getY()
	{
		return (int)dY;
	}
	
	public double getDY()
	{
		return dY;
	}
	
	public boolean equals(Object other)
	{
		Location o = (Location)other;
		return o.getX() == x && o.getY() == y;
	}
	
	public int compareTo(Object other)
	{
		if (this.equals(other))
			return 0;
		return 1;
	}
	
	public String toString()
	{
		return "(" + x + ", " + y + ")";
	}
}