import java.util.*;

public class PhysicsDemo1 implements GameEngine
{
	
	PhysicsEnvironment env;
	PointMass p;
	private final double SCALE = 0.1, GRAVITY = 9.8/SCALE;
	
	public PhysicsDemo1()
	{
		env = new PhysicsEnvironment(500,500);
		env.setGravity(new Vector2D(0,GRAVITY));
		
		Location loc = new Location(250.0,250.0);
	    p = new PointMass(loc,1.0);
	    env.addObject(p);
	}
	
	public void act(double t)
	{
		if (env.act(t,p))
		{
			Vector2D g = env.getGravity().scalarMult(-1.0);
			env.setGravity(g);
			if (p.getLoc().getDY() < 5.0)
				p.getLoc().setY(500-5.0);
			else
				p.getLoc().setY(5.0);
		}
	}
	
	public ArrayList getObjects()
	{
		return env.getObjects();
	}
	
}