import java.util.*;

public class PhysicsEnvironment
{
	private final double SCREEN_WIDTH, SCREEN_HEIGHT, ORIGIN_X, ORIGIN_Y;
	private ArrayList l;
	private Vector2D g;

	public PhysicsEnvironment(double w, double h)
	{
		SCREEN_WIDTH = w;
		SCREEN_HEIGHT = h;
		ORIGIN_X = SCREEN_WIDTH/2;
		ORIGIN_Y = SCREEN_HEIGHT/2;
		l = new ArrayList();
		g = new Vector2D(0,0);
	}

	public boolean addObject(PointMass p)
	{
		Iterator itr = l.iterator();
		while (itr.hasNext())
			if (checkCollision(p,(PointMass)itr.next()))
				return false;
		l.add(p);
		
		//add gravity
		p.accelerate(g);
		
		return true;
	}

	public boolean act(double dt, PointMass p1)
	{
		PointMass p2;
		boolean b = false;
		p1.act(dt);
		
		//iterate list to have each object act and check for collisions
		Iterator itr2 = l.iterator();
		while (itr2.hasNext())
		{
			p2 = (PointMass)itr2.next();
			if ((checkCollision(p1,p2) && p1 != p2) || checkCollision(p1))
			{
				System.out.println("Collision!");
				//insert collision reaction code here
				b = true;
			}
		}
		return b;
	}

	public ArrayList getObjects()
	{
		return l;
	}
	
	public void setGravity(Vector2D v)
	{
		PointMass p;
		for (int i = 0; i < l.size(); i++)
		{
			p = ((PointMass)l.get(i));
			p.deccelerate(g);
			p.accelerate(v);
		}
		g = v;
	}
	
	public Vector2D getGravity()
	{
		return g;
	}
	
	public boolean checkCollision(PointMass p1, PointMass p2)
	{
		return false;
	}
	
	//check for boundary collision
	public boolean checkCollision(PointMass p)
	{
		//System.out.println("Checking collision at " + p.getLoc());
		double x = p.getLoc().getDX();
		double y = p.getLoc().getDY();
		if (x < 5.0 || x > (double)SCREEN_WIDTH-5.0 || y < 5.0 || y > (double)SCREEN_HEIGHT-5.0)
		{
			System.out.println("Collision returned true at " + p.getLoc());
			return true;
		}
		else
			return false;
	}
}