public class PointMass
{
	private Location loc;
	private Vector2D v,a;
	private double m;
	
	public PointMass(Location l, double mass)
	{
		loc = l;
		v = new Vector2D();
		a = new Vector2D();
		m = mass;
	}
	
	public void act(double dt)
	{
		Vector2D b = a.scalarMult(dt);
		v = v.add(b);
		loc.setX(loc.getDX() + (v.getI()*dt));
		loc.setY(loc.getDY() + (v.getJ()*dt));
	}
	
	public void applyForce(Vector2D n)
	{
		n.setMag(n.magnitude() / m);
		accelerate(n);
	}
	
	public void accelerate(Vector2D d)
	{
		a = a.add(d);
	}
	
	public void deccelerate(Vector2D d)
	{
		a = a.subtract(d);
	}
	
	public void accelerate(double mag, double theta)
	{
		double x = mag*Math.cos(theta);
		double y = mag*Math.sin(theta);
		a = a.add(new Vector2D(x,y));
	}
	
	public void setSpeed(double d)
	{
		v.setMag(d);
	}
	
	public void setAccel(double d)
	{
		a.setMag(d);
	}
	
	public void setLoc(Location l)
	{
		loc = l;
	}
	
	public void setAccel(Vector2D acc)
	{
		a = acc;
	}
	
	public Location getLoc()
	{
		return loc;
	}
}