import java.util.*;

public class RotationalGravity implements GameEngine
{
	PhysicsEnvironment env;
	PointMass p;
	double theta;
	private final double SPEED = .1, GRAVITY = 9.8/SPEED, T_INCR = (Math.PI/3),
		WIDTH = 500, HEIGHT = 500;
	
	public RotationalGravity()
	{
		env = new PhysicsEnvironment(WIDTH,HEIGHT);
		env.setGravity(new Vector2D(0,GRAVITY));
		
		Location loc = new Location(5.0,WIDTH/2.0);
	    p = new PointMass(loc,1.0);
	    env.addObject(p);
	    theta = 0;
	}
	
	public void act(double t)
	{
		boolean b = env.act(t,p);
		Vector2D g = env.getGravity();
		Vector2D v = g.setAngle(theta);
		//v = v.scalarMult(1.001);
		env.setGravity(v);
		//p.setSpeed(10);
		//System.out.println("Gravity vector angle: " + v.getAngle());
		theta+=t*T_INCR;
		
		if (b)
		{
			p.getLoc().setY(5);
			if (p.getLoc().getDX() < 5.0)
				p.getLoc().setX(WIDTH-5.0);
			else if (p.getLoc().getDX() > WIDTH - 5.0)
				p.getLoc().setX(5.0);
		}
	}
	
	public ArrayList getObjects()
	{
		return env.getObjects();
	}	
}